// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AO8/18AO8_Linux_1.x_and_2.x_DN/include/18ao8_utils.h $
// $Rev: 52857 $
// $Date: 2023-04-17 14:34:43 -0500 (Mon, 17 Apr 2023) $

// 18AO8: Utilities: header file

#ifndef	__18AO8_UTILS_H__
#define	__18AO8_UTILS_H__

#include "18ao8_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ao8_close_util			(int fd, int index, int verbose);
int ao8_init_util			(int verbose);
int ao8_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ao8_open_util			(int device, int share, int index, int verbose, int* fd);
int ao8_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);
int	ao8_write_util			(int fd, int index, int verbose, const void* src, size_t bytes);

// IOCTL utility services

int	ao8_ao_config			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_AO_CONFIG
int	ao8_auto_cal_sts		(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_AUTO_CAL_STS
int	ao8_auto_calibrate		(int fd, int index, int verbose);								// AO8_IOCTL_AUTO_CALIBRATE
int	ao8_aux_clock_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_AUX_CLOCK_MODE
int	ao8_aux_in_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_AUX_IN_POL
int	ao8_aux_noise			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_AUX_NOISE
int	ao8_aux_out_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_AUX_OUT_POL
int	ao8_aux_sync_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_AUX_SYNC_MODE
int	ao8_buf_clear			(int fd, int index, int verbose);								// AO8_IOCTL_BUF_CLEAR
int	ao8_buf_fill_level		(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_BUF_FILL_LEVEL
int	ao8_buf_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_BUF_MODE
int	ao8_buf_over_data		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_BUF_OVER_DATA
int	ao8_buf_over_frame		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_BUF_OVER_FRAME
int	ao8_buf_status			(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_BUF_STATUS
int	ao8_buf_thresh_level	(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_BUF_THRESH_LEVEL
int	ao8_buf_thresh_status	(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_BUF_THRESH_STATUS
int	ao8_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_BURST_ENABLE
int	ao8_burst_ready			(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_BURST_READY
int	ao8_burst_trig_src		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_BURST_TRIG_SRC
int	ao8_channel_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_CHANNEL_SEL
int	ao8_clock_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_CLOCK_ENABLE
int	ao8_clock_ready			(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_CLOCK_READY
int	ao8_clock_src			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_CLOCK_SRC
int	ao8_clock_sw			(int fd, int index, int verbose);								// AO8_IOCTL_CLOCK_SW
int	ao8_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_DATA_FORMAT
int	ao8_dio_dir_out			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_DIO_DIR_OUT
int	ao8_dio_read			(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_DIO_READ
int	ao8_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_DIO_WRITE
int	ao8_gen_c_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_GEN_C_ENABLE
int	ao8_gen_c_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_GEN_C_NDIV
int	ao8_gen_d_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_GEN_D_ENABLE
int	ao8_gen_d_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_GEN_D_NDIV
int	ao8_initialize			(int fd, int index, int verbose);								// AO8_IOCTL_INITIALIZE
int	ao8_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_IRQ_ENABLE
int	ao8_load_ready			(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_LOAD_READY
int	ao8_load_request		(int fd, int index, int verbose);								// AO8_IOCTL_LOAD_REQUEST
int	ao8_output_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_OUTPUT_MODE
int	ao8_query				(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_QUERY
int	ao8_range				(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_RANGE
int	ao8_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AO8_IOCTL_REG_MOD
int	ao8_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AO8_IOCTL_REG_READ
int	ao8_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AO8_IOCTL_REG_WRITE
int	ao8_selftest_buf_clear	(int fd, int index, int verbose);								// AO8_IOCTL_SELFTEST_BUF_CLEAR
int	ao8_selftest_data_ready	(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_SELFTEST_DATA_READY
int	ao8_selftest_mode		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_SELFTEST_MODE
int	ao8_selftest_perform	(int fd, int index, int verbose);								// AO8_IOCTL_SELFTEST_PERFORM
int	ao8_selftest_read		(int fd, int index, int verbose, ao8_selftest_data_t* get);		// AO8_IOCTL_SELFTEST_READ
int	ao8_trigger_sw			(int fd, int index, int verbose);								// AO8_IOCTL_TRIGGER_SW
int	ao8_tx_io_abort			(int fd, int index, int verbose, s32* get);						// AO8_IOCTL_TX_IO_ABORT
int	ao8_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_TX_IO_MODE
int	ao8_tx_io_overflow_data	(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_TX_IO_OVERFLOW_DATA
int	ao8_tx_io_overflow_frame(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_TX_IO_OVERFLOW_FRAME
int	ao8_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_TX_IO_TIMEOUT
int	ao8_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO8_IOCTL_WAIT_CANCEL
int	ao8_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO8_IOCTL_WAIT_EVENT
int	ao8_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AO8_IOCTL_WAIT_STATUS
int	ao8_xcvr_output			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_XCVR_OUTPUT
int	ao8_xcvr_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_XCVR_POL
int	ao8_xcvr_type			(int fd, int index, int verbose, s32 set, s32* get);			// AO8_IOCTL_XCVR_TYPE

// Auxiliary utility services

int	ao8_config_ao			(int fd, int index, int verbose, s32 fsamp);
int	ao8_config_aux			(int fd, int index, int verbose);
int	ao8_config_dio			(int fd, int index, int verbose);
int	ao8_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	ao8_fsamp_ao_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	ao8_fsamp_ao_report_all	(int fd, int index, int verbose, s32* fsamp);
int	ao8_id_device			(int fd, int index, int verbose);

int	ao8_count_boards		(int verbose, s32* get);
int	ao8_fsamp_get			(int fd, int verbose, s32* get);
int	ao8_reg_list			(int fd, int detail);

const gsc_reg_def_t*		ao8_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*		ao8_reg_get_def_index		(int index);
const char*					ao8_reg_get_desc			(u32 reg);
const char*					ao8_reg_get_name			(u32 reg);



#endif
