// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AO8/18AO8_Linux_1.x_and_2.x_DN/samples/id/perform.c $
// $Rev: 52864 $
// $Date: 2023-04-17 14:40:41 -0500 (Mon, 17 Apr 2023) $

// 18AO8: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _output_modes(void)
{
	gsc_label("Output Modes");
	printf("Simultaneous, Immediate\n");
}



//*****************************************************************************
static void _output_configuration(void)
{
	gsc_label("Output Configuration");
	printf("Differential, Single Ended\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate-C Generator, External, Software\n");
}



//*****************************************************************************
static void _trigger_sources(void)
{
	gsc_label("Triggering Sources");
	printf("Rate-D Generator, External, Software\n");
}



//*****************************************************************************
static void _clocking_modes(void)
{
	gsc_label("Clocking Modes");
	printf("Continuous, Triggered Burst\n");
}



//*****************************************************************************
static void _rate_generators(void)
{
	gsc_label("Rate Generators");
	printf("2 (C and D)\n");
}



//*****************************************************************************
static void _transceivers(void)
{
	gsc_label("Control Transceivers");
	printf("LVDS, TTL, Bidirectional, Polarity\n");
}



//*****************************************************************************
static void _ranges(void)
{
	gsc_label("Voltage Ranges");
	printf("+-10 Volts, +-5 Volts, +-2.5 Volta\n");
}



//*****************************************************************************
static void _dio_ports(void)
{
	gsc_label("Digital I/O Ports");
	printf("8-bits, nibble-wise bidirectional\n");
}



//*****************************************************************************
static void _auxiliary(void)
{
	gsc_label("Auxiliary Signals");
	printf("Clock, Sync\n");

	gsc_label("Auxiliary Controls");
	printf("Disable, Input, Output, Polarity, Noise Sensitivity\n");
}



//*****************************************************************************
static void _io_modes(void)
{
	gsc_label("I/O Modes");
	printf("PIO, DMA  (DMDMA not supported)\n");
}



//*****************************************************************************
static int _id_device_acr(const args_t* args)
{
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= ao8_reg_get_def_id(AO8_GSC_ACR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, ao8_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. ao8_reg_get_def_id, AO8_GSC_ACR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ao8_reg_list(args->fd, args->detail);
 	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_output_modes();
	_output_configuration();
	_clocking_sources();
	_trigger_sources();
	_clocking_modes();
	_rate_generators();
	_transceivers();
	_ranges();
	_dio_ports();
	_auxiliary();
	_io_modes();

	for (i = 0; i < AO8_QUERY_LAST; i++)
		errs	+= ao8_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_acr(args);
	errs	+= _register_map(args);

	return(errs);
}


