// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AO8/18AO8_Linux_1.x_and_2.x_DN/utils/util_config_aux.c $
// $Rev: 52859 $
// $Date: 2023-04-17 14:38:13 -0500 (Mon, 17 Apr 2023) $

// 18AO8: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao8_config_aux
*
*	Purpose:
*
*		Configure the given device's auxiliary signals.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*
*		verbose	Work verbosely?
*
*		verbose	0: errors only, !0: all output
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int	ao8_config_aux(int fd, int index, int verbose)
{
	int	errs	= 0;

	if (verbose)
	{
		gsc_label_index("Auxiliary Configuration", index);
		printf("\n");
		gsc_label_level_inc();
	}

	errs	+= ao8_aux_clock_mode	(fd, index, verbose, AO8_AUX_MODE_OUTPUT,	NULL);
	errs	+= ao8_aux_in_pol		(fd, index, verbose, AO8_AUX_POL_HI,		NULL);
	errs	+= ao8_aux_noise		(fd, index, verbose, AO8_AUX_NOISE_HI,		NULL);
	errs	+= ao8_aux_out_pol		(fd, index, verbose, AO8_AUX_POL_HI,		NULL);
	errs	+= ao8_aux_sync_mode	(fd, index, verbose, AO8_AUX_MODE_OUTPUT,	NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}



