// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AO8/18AO8_Linux_1.x_and_2.x_DN/utils/util_config_dio.c $
// $Rev: 52859 $
// $Date: 2023-04-17 14:38:13 -0500 (Mon, 17 Apr 2023) $

// 18AO8: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao8_config_dio
*
*	Purpose:
*
*		Configure the given device using common defaults.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int	ao8_config_dio(int fd, int index, int verbose)
{
	int	errs	= 0;

	if (verbose)
	{
		gsc_label_index("DIO Configuration", index);
		printf("\n");
		gsc_label_level_inc();
	}

	errs	+= ao8_dio_dir_out	(fd, index, verbose, AO8_DIO_DIR_OUT_D7_D0,	NULL);
	errs	+= ao8_dio_write	(fd, index, verbose, 0xFF,					NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}



