// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AO8/18AO8_Linux_1.x_and_2.x_DN/utils/util_selftest_read.c $
// $Rev: 52859 $
// $Date: 2023-04-17 14:38:13 -0500 (Mon, 17 Apr 2023) $

// 18AO8: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ao8_selftest_read
*
*	Purpose:
*
*		Provide a visual wrapper for the AO8_IOCTL_SELFTEST_READ service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao8_selftest_read(int fd, int index, int verbose, ao8_selftest_data_t* get)
{
	int					errs;
	int					ret;
	ao8_selftest_data_t	set;

	if (verbose)
		gsc_label_index("Self Test Data Read", index);

	ret		= ao8_ioctl(fd, AO8_IOCTL_SELFTEST_READ, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	if (get)
		get[0]	= set;

	return(errs);
}


